class PtpDevice

	@@gphoto2_cmd = '/usr/bin/gphoto2'
	@@months = Hash['Jan',  1, 'Feb',  2, 'Mar',  3, 'Apr',  4, 'May',  5, 'Jun',  6, 'Jul',  7, 'Aug',  8, 'Sep',  9, 'Oct', 10, 'Nov', 11, 'Dec', 12]

	def initialize
		ENV['LANG']= 'C'
	end

	def get_filelist
		yield('get_filelist')
		sq = 0; @names = []; @sq_name = {}
		IO.popen('%s --list-files' % @@gphoto2_cmd) {|io|
			io.each {|line|
				if(line =~ /^#(\d+)\s+(\S+)/)
					@names << $2; @sq_name[$2] = sq; yield('.')
					(sq += 1) == $1.to_i or raise '--list-files failed #1.'
				end
			}
		}
		(it = $?.exitstatus and it == 0) or raise '--list-files failed #2. try "pkill gvfsd-gphoto2".'
		@get_sqs = []
		yield("\n")
	end

	def get_exifs
		yield('get_exifs')
		@exifs = []; @model = 'Unknown'
		IO.popen('%s --show-exif 1-%d 2>/dev/null' % [@@gphoto2_cmd, @names.size]) {|io|
			exif = {}; io.each {|line|
				if(line =~ /^EXIF tags:/)
					it = exif['Model'] and @model = it.split(/\s+/).last
					@exifs << exif; exif = {}; yield('.')
				else
					line =~ /(.+?)\|(.+)/ and exif[$1.strip] = $2.strip
				end
			}
			@exifs << exif; @exifs.shift
		}
		(it = $?.exitstatus and it == 0) or raise '--show-exifs failed #1.'
		@exifs.size == @names.size or raise '--show-exifs failed #2.'
		yield("\n")
	end

	def get_exifs_plus
		get_exifs {|x| yield(x) }
		yield('get_exifs_plus')
		n = -1; IO.popen('%s --show-info 1-%d 2>/dev/null' % [@@gphoto2_cmd, @names.size]) {|io|
			io.each {|line|
				if(line =~ /^File:/)
					n += 1; yield('.')
				elsif(line =~ /^\s+Time:.*(\w{3})\D(\d{2})\D(\d{2})\D+(\d{2})\D(\d{2})\D(\d{4})/ and month = @@months[$1])
					it = @exifs[n] and it['DateTime_#FromInfo#'] = '%04d:%02d:%02d %02d:%02d:%02d' % [$6.to_i, month, $2.to_i, $3.to_i, $4.to_i, $5.to_i]
				end
			}
		}
		(it = $?.exitstatus and it == 0) or raise '--show-info failed #1.'
		n + 1 == @names.size or raise '--show-info failed #2.'
		yield("\n")
	end

	def each_file
		@names.each {|fileName|
			yield(fileName)
		}
	end

	def get_exif_sq(sq)
		@exifs[sq - 1]
	end

	def get_exif(fileName)
		@exifs[@sq_name[fileName]]
	end

	def get_file(fileName, dirName)
		prefix = ((it = get_exif(fileName)['Model']) ? it.split(/\s+/).last : @model) + '_'
		IO.popen('%s --get-file %d --filename %s/%s%s --force-overwrite 2>/dev/null' % [@@gphoto2_cmd, get_sq = @sq_name[fileName] + 1, dirName, prefix, fileName]) {|io|
			io.each {|line|
				yield(line)
			}
		}
		(it = $?.exitstatus and it == 0) or raise '--get-file failed.'
		@get_sqs << get_sq
	end

	def get_thumbnails(dirName)
		IO.popen('%s --get-thumbnail %s --filename %s/%f.%C' % [@@gphoto2_cmd, @get_sqs.join(','), dirName]) {|io|
			io.each {|line|
				yield(line)
			}
		}
		(it = $?.exitstatus and it == 0) or raise '--get-thumbnail failed.'
		@get_sqs
	end
end

__END__

